'use strict';

document.getStreams = () => {
  return ['electrics', 'engineInfo'];
}

let width = 660;
let height = 660;
let rpmTextSize = 50; // in px
let rpmTextCount = 14;
let rpmOffset = 400;
let rpmRange = 600;
let barDashCount = 4;
let barDashSize1 = 5;
let barDashSize2 = 5;
let revNeedleTrailDashSize = 5;
let revCurveDashSize1 = 10;
let revCurveDashSize2 = 6;

let tachometer = new TachometerV2(
  width,
  height,
  rpmTextSize,
  rpmTextCount,
  rpmOffset,
  rpmRange,
  barDashCount,
  barDashSize1,
  barDashSize2,
  revNeedleTrailDashSize,
  revCurveDashSize1,
  revCurveDashSize2,
  document.getElementById('tacho2speed'),
  document.getElementById('speedunit'),
  document.getElementById('revcurve_dashes'),
  document.getElementById('revneedle'),
  document.getElementById('rpm_redline'),
  document.getElementById('rpmtextline'),
  document.getElementById('tacho2gear'),
  document.getElementById('center_circle'),
  document.getElementById('revcurve'),
  document.getElementById('revmask'),
  document.getElementById('revtrail'),
  document.getElementById('temp'),
  document.getElementById('temp_dashes'),
  document.getElementById('fuel'),
  document.getElementById('fuel_dashes'),
  document.getElementById('ico_handbrake_on'),
  document.getElementById('ico_abs_on'),
  document.getElementById('ico_indicatorl_on'),
  document.getElementById('ico_indicatorr_on'),
  document.getElementById('ico_lights_on'),
  document.getElementById('ico_lights_high'),
  document.getElementsByClassName("tacho_glow")
);

let controller = new TachometerV2Controller();
controller.setLayersVisible(false);

let UiUnitscallback;

let unitSpeed = (val) => {
  let convertedVal = UiUnitscallback(val, 'speed');
  tachometer.speedUnitTextElement.textContent = convertedVal.unit;
  return Math.round(convertedVal.val);
}

document.roundDec = () => 0;

document.wireThroughUnitSystem = (callback) => {
  UiUnitscallback = callback;
}

document.reset = () => {
  controller.setLayersVisible(false);
  tachometer.initialized = false;
}

document.update = (streams) => {
  if (!tachometer.initialized) {
    controller.init(tachometer, streams);
  }
  controller.update(tachometer, streams);
}

let switchRedlineMode = () => {
  controller.switchRedlineMode(tachometer);
}

let switchRevTrailMode = () => {
  controller.switchRevTrailMode(tachometer);
}

document.vehicleChanged = () => {
  tachometer.initialized = false;
}

document.saveData = () => {
  controller.saveData(tachometer);
}
